<template>
  <div class="avatar-container">
    <img
      v-if="imageUrl"
      class="avatar"
      :src="imageUrl"
      alt="character avatar"
    />
    <span class="character-name">{{ characterName }}</span>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex'

const storeModules = {
  player: createNamespacedHelpers('player')
}

export default {
  computed: {
    ...storeModules.player.mapState(['age']),

    characterName() {
      const { name: routeName } = this.$route
      if (routeName === 'light-world') {
        return 'Sun'
      } else if (routeName === 'shadow-world') {
        return 'Loon'
      }

      return ''
    },

    imageUrl() {
      const { name: routeName } = this.$route
      if (routeName === 'light-world') {
        const ageLevel = Math.floor(this.age / 20) + 1
        return require(`~/static/avatar/sun_${ageLevel}.png`)
      } else if (routeName === 'shadow-world') {
        return require('~/static/avatar/shadow.png')
      }

      return null
    }
  }
}
</script>

<style>
.avatar-container .avatar {
  box-shadow: 0 0 10px black;
  position: absolute;
  top: 0;
  width: 216px;
}

.light-world .avatar {
  left: -216px;
  background-color: rgba(255, 255, 255, 0.7);
}

.shadow-world .avatar {
  right: -216px;
  background-color: rgba(0, 0, 0, 0.2);
}

.page-leave-active .avatar,
.page-leave-active .character-name {
  display: none;
}

.character-name {
  position: absolute;
  width: 216px;
  text-align: center;
  top: 0;
  padding-top: 4px;
  opacity: 0.8;
  font-size: 24px;
  font-weight: bold;
}

.light-world .character-name {
  left: -216px;
}

.shadow-world .character-name {
  right: -216px;
}
</style>
